// attract.h
// Play Mechanix - Video Game System
// Copyright (c) 2010 Play Mechanix Inc. All Rights Reserved
//

#ifndef AUD_GAME_H
#define AUD_GAME_H

#include "game.h"


typedef enum GameplayAudItemType
{
	// line with text but no value
	GPAUD_NOVALUE,

	GPAUD_TOTAL_TIME_PLAYED,
	GPAUD_TOTAL_TIME_PLAYED_1P,
	GPAUD_TOTAL_TIME_PLAYED_2P,

	GPAUD_TIME_PER_GAME,
	GPAUD_TIME_PER_GAME_1P,
	GPAUD_TIME_PER_GAME_2P,

	GPAUD_TIME_PER_CREDIT,
	GPAUD_TIME_PER_CREDIT_1P,
	GPAUD_TIME_PER_CREDIT_2P,

	GPAUD_TIME_PER_CREDIT_TRICERA_G0,
	GPAUD_TIME_PER_CREDIT_TRICERA_G1_2,
	GPAUD_TIME_PER_CREDIT_TRICERA_G3,
	GPAUD_TIME_PER_CREDIT_TRICERA_G4,

	GPAUD_TIME_PER_CREDIT_TREX_G2,
	GPAUD_TIME_PER_CREDIT_TREX_G3,
	GPAUD_TIME_PER_CREDIT_TREX_G4,
	GPAUD_TIME_PER_CREDIT_TREX_G5,
	GPAUD_TIME_PER_CREDIT_TREX_G6,

	GPAUD_TIME_PER_CREDIT_BRACH_G1,
	GPAUD_TIME_PER_CREDIT_BRACH_G2,
	GPAUD_TIME_PER_CREDIT_BRACH_G3,

	GPAUD_LEVEL_STARTS_TITLE,
	GPAUD_LEVEL_FINISHES_TITLE,

	GPAUD_STARTS,
	GPAUD_STARTS_1P,
	GPAUD_STARTS_2P,

	GPAUD_FINISHED_0_LEVELS,
	GPAUD_FINISHED_1_LEVEL,
	GPAUD_FINISHED_2_LEVELS,

	GPAUD_LEVEL_COMPLETIONS,
	GPAUD_LEVEL_COMPLETIONS_1P,
	GPAUD_LEVEL_COMPLETIONS_2P,

	GPAUD_GAME_COMPLETIONS,
	GPAUD_GAME_COMPLETIONS_1P,
	GPAUD_GAME_COMPLETIONS_2P,

	GPAUD_CONTINUES_TITLE,
	GPAUD_CONTINUES,
	GPAUD_CONTINUES_1P,
	GPAUD_CONTINUES_2P,
	GPAUD_CONTINUE_LEVEL_TRICERA,
	GPAUD_CONTINUE_LEVEL_TREX,
	GPAUD_CONTINUE_LEVEL_BRACH,

	GPAUD_PLAYERS_STARTED,
	
	GPAUD_ABANDONS,

	GPAUD_LEVEL_AVG_FAILS,
	GPAUD_LEVEL_AVG_FAILS_1P,
	GPAUD_LEVEL_AVG_FAILS_2P,
	GPAUD_LEVEL_AVG_FAILS_TRICERA,
	GPAUD_LEVEL_AVG_FAILS_TREX,
	GPAUD_LEVEL_AVG_FAILS_BRACH,

	GPAUD_LEVEL_WINS_AFTER_FAIL,
	GPAUD_LEVEL_WINS_AFTER_FAIL_1P,
	GPAUD_LEVEL_WINS_AFTER_FAIL_2P,

	GPAUD_START_LEVEL_TRICERA,
	GPAUD_START_LEVEL_TREX,
	GPAUD_START_LEVEL_BRACH,

	GPAUD_COMPLETE_LEVEL_TRICERA,
	GPAUD_COMPLETE_LEVEL_TREX,
	GPAUD_COMPLETE_LEVEL_BRACH,

	GPAUD_PICKUP_HEALTH,
	GPAUD_PICKUP_BONUS,
	GPAUD_PICKUP_WEAPON_ELECTRO,
	GPAUD_PICKUP_WEAPON_ROCKET,
	GPAUD_PICKUP_WEAPON_SHOTGUN,
	GPAUD_PICKUP_WEAPON_MINIGUN,
	GPAUD_PICKUP_WEAPON_FREEZERAY,
	GPAUD_PICKUP_TOTAL,

	GPAUD_GRENADES_FIRED,
	GPAUD_FIRED_ANY_GRENADES,

	GPAUD_DAMAGE_TAKEN_TITLE,

	GPAUD_DAMAGE_TAKEN_RAPTOR,
	GPAUD_DAMAGE_TAKEN_RAPTOR_CHASE,
	GPAUD_DAMAGE_TAKEN_RAPTOR_GRAPPLE,
	GPAUD_DAMAGE_TAKEN_DILO,
	GPAUD_DAMAGE_TAKEN_MRAPTOR,
	GPAUD_DAMAGE_TAKEN_WASP,
	GPAUD_DAMAGE_TAKEN_PTERA,
	GPAUD_DAMAGE_TAKEN_BUG,
	GPAUD_DAMAGE_TAKEN_COMPY,
	GPAUD_DAMAGE_TAKEN_CIRCLE,
	GPAUD_DAMAGE_TAKEN_OBSTACLE,
	GPAUD_DAMAGE_TAKEN_OTHER,

	GPAUD_KILL_TITLE,

	GPAUD_KILL_RAPTOR,
	GPAUD_KILL_RAPTOR_CHASE,
	GPAUD_KILL_RAPTOR_GRAPPLE,
	GPAUD_KILL_DILO,
	GPAUD_KILL_MRAPTOR,
	GPAUD_KILL_WASP,
	GPAUD_KILL_PTERA,
	GPAUD_KILL_BUG,
	GPAUD_KILL_COMPY,
	GPAUD_KILL_CIRCLE,
	GPAUD_KILL_CIRCLE_SEQUENCE,
	GPAUD_KILL_OBSTACLE,

	GPAUD_MOTION_BUTTON_STOPS,
	GPAUD_MOTION_BUTTON_RESUMES,
	GPAUD_MOTION_BUTTON_MANUAL_RESUMES,
	GPAUD_MOTION_MAT_STOPS,
	GPAUD_MOTION_FAN_ERRORS,
	GPAUD_MOTION_LOW_PSI,
	GPAUD_MOTION_DISCONNECTS,

	NUM_GAMEPLAY_AUD_ITEM_TYPES

} GameplayAudItemType;


int AudGame_Init();
int AudGame_InitDefaults();
int AudGame_SaveNewHighscoreDefaults();

LevelAudit* AudGameGetLevelAud(int level, uns32 nPlyrs);
int* AudGameGetPickupAudType(int level, uns32 nPlyrs, PICKUP_TYPE type);
void AudGameExport(FILE* fd);

void AudGame_GetValueStr(GameplayAudit* ga, GameplayAudItemType type, char* buf);

#endif // AUD_GAME_H

