
#ifndef CERA_STATEMACHINE_H
#define CERA_STATEMACHINE_H


// various states used for cera behaviors
enum
{
	CERA_ATTACK_NONE,
	CERA_ATTACK_ANIM_START_LEFT,
	CERA_ATTACK_ANIM_START_CENTER,
	CERA_ATTACK_ANIM_START_RIGHT,
	CERA_ATTACK_ANIM_PLAY1,
	CERA_ATTACK_SCREEN_HIT,
	CERA_ATTACK_ANIM_PLAY2,
	CERA_ATTACK_RAMPDOWN,
	CERA_ATTACK_RAMPUP,
	CERA_ATTACK_INTERRUPT,
	CERA_ATTACK_DEAD,
	CERA_ATTACK_DONE
};

enum
{
	CERA_HIT_NONE,
	CERA_HIT_SLOW,
};

enum
{
	CERA_TRANS_START,
	CERA_TRANS_DO_IT,
	CERA_TRANS_END
};

enum
{
	CERA_FLASH_NONE,
	CERA_FLASH_START,
	CERA_FLASH_ON,
	CERA_FLASH_OFF	
};


enum CeraStateMachineStates
{
	SM_CERASTATES_INIT = SM_GAMESTATES_MAX,
	SM_CERASTATES_CHASE,
	SM_CERASTATES_HIT_SLOW,
	SM_CERASTATES_SPHERE_INIT,
	SM_CERASTATES_SPHERE_TEST,

	SM_CERASTATES_MAX,
	NUM_SM_CERASTATES = (SM_CERASTATES_MAX - SM_GAMESTATES_MAX),
};

extern PSM_State gCeraStateMachineStates[NUM_SM_CERASTATES];
extern PSM_StateMachine gCeraStateMachine;

int SM_Cera_Init( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time  );
int SM_Cera_Chase( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time );
int SM_Cera_HitSlow( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time );
int SM_Cera_SphereInit( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time );
int SM_Cera_SphereTest( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time );

#endif


