#ifndef DINO_GROUP_H
#define DINO_GROUP_H


#include "game.h"


#define DINO_GROUP_MAX			64
#define DINO_GROUP_MAX_OBJS		32
#define DINO_GROUP_NAME_LEN		32

// group update callback function
typedef void (*DinoGroup_UpdateCallback)( void* grp, void* data );
typedef void (*DinoGroup_DestroyCallback)( void* grp );


typedef struct DinoGroup
{
	uns32 id;
	uns32 num_objs;
	Obj* objs[DINO_GROUP_MAX_OBJS];
	uns32 oids[DINO_GROUP_MAX_OBJS];
	int in_use;
	char name[DINO_GROUP_NAME_LEN];
	uns32 create_tcnt;

	// group update function
	DinoGroup_UpdateCallback update_callback;
	void* update_callback_data;
	ObjFunc* obj_func;
	DinoGroup_DestroyCallback destroy_callback;
} DinoGroup;

void DinoGroup_Reset();
DinoGroup* DinoGroup_GetByID( int id );
DinoGroup* DinoGroup_GetByName( char* groupName );
int DinoGroup_Register( char* groupName );
int DinoGroup_SetUpdateCallback( int id, DinoGroup_UpdateCallback callback, void* data );
int DinoGroup_SetDestroyCallback( int id, DinoGroup_DestroyCallback callback );
int DinoGroup_IsRegistered( char* groupName );
int DinoGroup_GetGroupCnt();

#endif


