
#ifndef ENEMY_STATEMACHINE_H
#define ENEMY_STATEMACHINE_H



enum EnemyStateMachineStates
{
	SM_ENEMYSTATES_ENEMY_INIT = SM_GAMESTATES_MAX,
	SM_ENEMYSTATES_ENEMY_SET_HEALTH,
	SM_ENEMYSTATES_ENEMY_SHOT,
	SM_ENEMYSTATES_DAMAGE_PLAYER,
	SM_ENEMYSTATES_DAMAGE_PLAYER_CIRCLES,
	SM_ENEMYSTATES_DAMAGE_PLAYER_CIRCLES_END,
	SM_ENEMYSTATES_DAMAGE_PLAYER_DILO,
	SM_ENEMYSTATES_RUN_SPLINE,
	
	// Circles
	SM_ENEMYSTATES_ADDCIRCLE,
	SM_ENEMYSTATES_BR_ON_CIRCLES,
	SM_ENEMYSTATES_WAIT_ON_CIRCLES,
	SM_ENEMYSTATES_CLEAR_CIRCLE_SUCCESS_COUNT,
	SM_ENEMYSTATES_BR_ON_CIRCLE_SUCCESS,
	SM_ENEMYSTATES_CIRCLE_WAIT_BR_ON_SUCCESS,
	SM_ENEMYSTATES_KILL_CIRCLES,
	SM_ENEMYSTATES_AWARD_SURVIVOR,

	SM_ENEMYSTATES_MAX,
	NUM_SM_ENEMYSTATES = (SM_ENEMYSTATES_MAX - SM_GAMESTATES_MAX),
};

// Do this in define so that enemy state 
#define SM_ENEMY_STATES \
	{ SM_ENEMYSTATES_ENEMY_INIT, "ENEMY_INIT", "NULL", 0, 0, SM_Enemy_Init}, \
	{ SM_ENEMYSTATES_ENEMY_SET_HEALTH, "ENEMY_SET_HEALTH", "SM_Health", 0, 0, SM_Enemy_SetHealth}, \
	{ SM_ENEMYSTATES_ENEMY_SHOT, "ENEMY_SHOT", "NULL", 0, 0, SM_Enemy_Shot}, \
	{ SM_ENEMYSTATES_DAMAGE_PLAYER, "DAMAGE_PLAYER", "SM_Enemy_DamagePlayer_Params", 0, 0, SM_Enemy_Damage_Player}, \
	{ SM_ENEMYSTATES_DAMAGE_PLAYER_CIRCLES, "DAMAGE_PLAYER_CIRCLES", "SM_Enemy_DamagePlayer_Params", 0, 0, SM_Enemy_Damage_Player_Circles}, \
	{ SM_ENEMYSTATES_DAMAGE_PLAYER_CIRCLES_END, "DAMAGE_PLAYER_CIRCLES_END", "SM_Enemy_DamagePlayer_Params", 0, 0, SM_Enemy_Damage_Player_Circles_End}, \
	{ SM_ENEMYSTATES_DAMAGE_PLAYER_DILO, "DAMAGE_PLAYER_DILO", "NULL", 0, 0, SM_Enemy_Damage_Player_Dilo}, \
	{ SM_ENEMYSTATES_RUN_SPLINE, "ENEMY_RUN_SPLINE", "NULL", 0, 0, SM_Enemy_Run_Spline}, \
	\
	{ SM_ENEMYSTATES_ADDCIRCLE,	"ADD_CIRCLE",	"SM_Enemy_AddCircle_Params",	0, 0,  SM_EnemyAddCircleFunc }, \
	{ SM_ENEMYSTATES_BR_ON_CIRCLES,	"BR_ON_CIRCLES",	"SM_Label",	0, 0,  SM_EnemyBrOnCirclesFunc }, \
	{ SM_ENEMYSTATES_WAIT_ON_CIRCLES,	"WAIT_FOR_CIRCLES",	"SM_Time",	0, 0,  SM_EnemyWaitForCirclesFunc }, \
	{ SM_ENEMYSTATES_BR_ON_CIRCLE_SUCCESS,	"BR_ON_CIRCLE_SUCCESS_COUNT",	"SM_CountAndLabel",	0, 0,  SM_EnemyBrOnCircleSuccessFunc }, \
	{ SM_ENEMYSTATES_CLEAR_CIRCLE_SUCCESS_COUNT,	"CLEAR_CIRCLE_SUCCESS_COUNT",	"NULL",	0, 0,  SM_EnemyClearCircleSuccessesFunc }, \
	{ SM_ENEMYSTATES_CIRCLE_WAIT_BR_ON_SUCCESS,	"CIRCLE_WAIT_BR_ON_SUCCESS",	"SM_EnemyWaitCircle_Params",	0, 0,  SM_EnemyWaitForCircleBrSuccessFunc }, \
	{ SM_ENEMYSTATES_KILL_CIRCLES,	"KILL_CIRCLES",	"NULL",	0, 0,  SM_EnemyKillCirclesFunc }, \
	{ SM_ENEMYSTATES_AWARD_SURVIVOR, "AWARD_SURVIVOR", "NULL", 0, 0, SM_EnemyAwardSurvivor }



extern PSM_State gEnemyStateMachineStates[NUM_SM_ENEMYSTATES];
extern PSM_StateMachine gEnemyStateMachine;

int SM_Enemy_Init( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time  );
int SM_Enemy_SetHealth( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time  );
int SM_Enemy_Shot( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time  );
int SM_Enemy_Damage_Player( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time  );
int SM_Enemy_Damage_Player_Circles( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time  );
int SM_Enemy_Damage_Player_Circles_End( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time  );
int SM_Enemy_Damage_Player_Dilo( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time  );
int SM_Enemy_Run_Spline( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time  );

int SM_EnemyAddCircleFunc( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time  );
int SM_EnemyBrOnCirclesFunc( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time  );
int SM_EnemyWaitForCirclesFunc( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time  );
int SM_EnemyBrOnCircleSuccessFunc( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time  );
int SM_EnemyClearCircleSuccessesFunc( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time  );
int SM_EnemyWaitForCircleBrSuccessFunc( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time  );
int SM_EnemyKillCirclesFunc( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time  );
int SM_EnemyAwardSurvivor( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time  );


typedef enum EnemyCircleType
{
	ENEMY_CIRCLE_TYPE_DFLT,
	ENEMY_CIRCLE_TYPE_TIME,

} EnemyCircleType;


int EnemyCountCircles( uns32 CircleGroupOID  );
int EnemyCountAddCircles( uns32 CircleGroupOID );
int EnemyKillCircles( uns32 CircleGroupOID, uns32 AddCircleGroupOID, int* circleExplId );
int EnemyAddCircle( Obj *prime, Obj *attach_obj, SM_Enemy_AddCircle_Params *params, SM_Enemy_Params *pSMECP, Obj *second_ding_obj, char *second_ding_anim, Obj* notify_kill );
int EnemyCreateCircleODR(ObjDispRes** o, char* resName, ObjGroup* grp, int i, float startScale, float scaleMin, float scale_in_speed, float angle, float spin);
int EnemyDoCircleDamage( Obj *prime, uns32 CircleGroupOID, EnemyCircleType enemyType, ObjColAct *cola, SM_Enemy_Params *pSMECP );
int EnemyDoCircleColorBlend(ObjDispRes* circle, SM_CircleData* cdata, float blend);
int EnemyKillCircle(ObjDispRes* circle, SM_CircleData* cdata);
void EnemyCreateCircleBits(crd *pos2D, float radius, crd* clr, crd* flashClr);
void EnemyCreateCircleFlash(crd* pos2D, float radius, float* clr, ObjDispRes** obj);
void EnemyCreateFailCircle(ObjGroup* grp, ObjDispRes* circle, float radius, float* clr);
void EnemyCircleExplosionCB( ExplosionData* expData, void* data );
void EnemyDamageCircle(SM_Enemy_Params* params, ObjDispRes* circle, SM_CircleData* cdata, ObjVel* cvel, int killPnum, float damage);
void EnemyCheckCircleHP(ObjDispRes* circle, SM_CircleData* cdata, int killPnum, EnemyCircleType enemyType);

void EnemyScreenHitDecal( int numP, int plnum );
void EnemyScreenHitDecalTest();

#endif


