// game_flow.h
// Play Mechanix - Video Game System
// Copyright (c) 2010 Play Mechanix Inc. All Rights Reserved
//

#ifndef GAME_FLOW_H
#define GAME_FLOW_H

#include "game.h"

int UsingOldLevelSelect();
char* GetGameLevelName(int levelId);


int GameFlowProcStart(void *params);
void GameFlowProcRun();
void GameFlowProcKill(void *params);

int GameFlow_CheckForJoin();
void GameFlow_LevelSelect();
void GameFlow_RunLevel(char* level);
void GameFlow_RunFinishScene();
void GameFlow_RunCredits();
void GameFlow_LevelComplete();
void GameFlow_MidGameBangup();

void GameFlow_LevelRunCallback();
void GameFlow_LevelEndCallback(int recordAudits);

void GameFlow_SetCurrentLevel( int i );
int GameFlow_GetCurrentLevel();

int GameFlow_NumDinosCaptured();
int GameFlow_AllDinosCaptured();

int GameFlow_DoLoadScreen();
void GameFlow_DoLoadScreen_Set(int doLoadScreen);

void GameFlow_UpdateQRCode();


// Continue proc
int Continue_ProcStart(void *params);
void Continue_ProcRun();
void Continue_ProcKill(void *params);


void ToolProcRun(void *params);


void GunsOn();
void GunsOff();
void GunsOff_HoldFire();

void FlashlightOn();
void FlashlightOff();


//extern char gGameLevels[GAME_NUM_LEVELS][SM_NAME_SIZE];
extern int gPlayerInputStart[GAME_MAX_PLAYERS];
extern int gPlayerInputTrig0[GAME_MAX_PLAYERS];
extern int gPlayerInputTrig1[GAME_MAX_PLAYERS];
extern int gPlayerInputTrig2[GAME_MAX_PLAYERS];


#endif // GAME_FLOW_H

