// full-auto. machine gun
#ifndef GAME_GUN_MINIGUN_H
#define GAME_GUN_MINIGUN_H


#include "game.h"


#define GUN_MINIGUN_NUMPARTS	2


// for each player
typedef struct PlayerMinigunData
{
	uns32 last_shot_time;
	int ammo_cnt;
	int launch_bullet;

	// shooting kickback
	float kickback_spring_vel;
	float kickback_spring_scale;
	float kickback_vibration;

	// sfx data
	int sfx_state;
	uns32 sfx_id;
	uns32 sfx_rumble_id;
	uns32 sfx_last_fire_tick;
	uns32 sfx_end_cnt;
	uns32 sfx_end_tick;

} PlayerMinigunData;
extern PlayerMinigunData gPlayerMinigun[GAME_MAX_PLAYERS];

void GunMinigunSetConfig();

int GunMinigunOn(int pnum);
int GunMinigunDisable(int pnum);
int GunMinigunUpdate(int pnum);

int GunMinigunShoot( int input, uns32 state, io_input_analog *ai, io_input_digital *trigger, void *data );
int GunMinigunShootAuto( int input, uns32 state, io_input_analog *ai, io_input_digital *trigger, void *data );

void GunMinigunLaunchBullet(GunMuzzleData* gmd, float gunScale, int randomize);
void GunMinigunKickBack(GunMuzzleData* gmd);

int GunMinigunGetPickupAmmo();
int GunMinigunGetCurAmmo( int pnum );

uns32 GunMinigun_StartRumble();


#endif