#ifndef GAME_GUN_SHOTGUN_H
#define GAME_GUN_SHOTGUN_H


#include "game.h"


#define GUN_SHOTGUN_NUMPARTS	3

// for each player
typedef struct PlayerShotgunData
{
	uns32 last_shot_time;
	int ammo_cnt;
	int launch_bullet;

	// shooting kick back
	float kickback_spring_vel[GUN_SHOTGUN_NUMPARTS];
	float kickback_spring_scale[GUN_SHOTGUN_NUMPARTS];

} PlayerShotgunData;
extern PlayerShotgunData gPlayerShotgun[GAME_MAX_PLAYERS];

void GunShotgunSetConfig();

int GunShotgunOn(int pnum);
int GunShotgunOff(int pnum);

int GunShotgunShoot( int input, uns32 state, io_input_analog *ai, io_input_digital *trigger, void *data );
int GunShotgunShootAuto( int input, uns32 state, io_input_analog *ai, io_input_digital *trigger, void *data );

void GunShotgunLaunchBullet(GunMuzzleData* gmd);
void GunShotgunKickBack(GunMuzzleData* gmd);

int GunShotgunGetPickupAmmo();
int GunShotgunGetCurAmmo( int pnum );

uns32 GunShotgun_StartRumble();

#endif