// data for one dino following a path with other dinos in a group


#ifndef GRP_PATH_H_
#define GRP_PATH_H_


typedef struct GrpPathData
{
	ResDataKan* kan;
	ResDataKanKey* keys;
	ResDataKanKey* curKey;
	crd kanVel[V3_SIZE];
	crd kanVelDir[V3_SIZE];
	float kanSpeed;
	// time of current key from the start of the spline
	float curKeyTime;
	// current position of seek point on spline
	crd splinePos[V3_SIZE];
	crd tgt[V3_SIZE];
	// normalized vector offset from target
	crd offset[V3_SIZE];
	float offsetLen;
	float maxOffsetLen;
	// rotational velocity around the swarm spline
	crd rotVel;
	crd rotVelMult;
	crd splineDir[V3_SIZE];
	int done;
	// true if keys should be interpreted as being in the target's space
	// (for translation only)
	int useTgtSpace;

	uns32 launchTime;

	crd tgtPos[V3_SIZE];

} GrpPathData;


void GrpPath_Init(GrpPathData* data, ResDataKan* kanRes);
void GrpPath_Update(GrpPathData* data, crd* tgtPos, uns32 launchTime);

// true if has a spline and is still following it
int GrpPath_IsActive(GrpPathData* data);
// force the spline to end and become inactive
void GrpPath_End(GrpPathData* data);


#endif