#ifndef LAMPS_H
#define LAMPS_H

// lights.h


typedef enum LAMP_TYPE
{
	LAMP_P1START,			//P1 START LAMP
	LAMP_P2START,			//P2 START LAMP
	LAMP_DINOHEAD,			//DINO HEAD MARQUEE
	LAMP_LOGO,				//JP TEXT LOGO BACKLIGHT
	LAMP_ROOF,				//ROOF LED T-MOLD - RED
	LAMP_MARQUEE,			//MARQUEE BACKLIGHT
	LAMP_DASH,				//DASH ARTWORK BACKLIGHT
	LAMP_FOLIAGE,			//FOLIAGE UPLIGHT
	LAMP_MOTION_BASE_R,		//MOTION BASE RED
	LAMP_P1GUN_R,			//P1 GUN RGB TRIM - RED
	LAMP_P1GUN_G,			//P1 GUN RGB TRIM - GREEN
	LAMP_P1GUN_B,			//P1 GUN RGB TRIM - BLUE
	LAMP_P2GUN_R,			//P2 GUN RGB TRIM - RED
	LAMP_P2GUN_G,			//P2 GUN RGB TRIM - GREEN
	LAMP_P2GUN_B,			//P2 GUN RGB TRIM - BLUE
	LAMP_DASH_TMOLD_R,		//DASH T-MOLD RED
	LAMP_DASH_TMOLD_G,		//DASH T-MOLD GREEN
	LAMP_DASH_TMOLD_B,		//DASH T-MOLD BLUE
	LAMP_WOOFER_R,			//WOOFER RING - RED
	LAMP_WOOFER_G,			//WOOFER RING - GREEN
	LAMP_WOOFER_B,			//WOOFER RING - BLUE
	LAMP_SEAT_R,			//CABINET RGB T-MOLD - RED
	LAMP_SEAT_G,			//CABINET RGB T-MOLD - GREEN
	LAMP_SEAT_B,			//CABINET RGB T-MOLD - BLUE
	LAMP_BENCH_LOGO,		//JP ROUND LOGO BACKLIGHT
	LAMP_GUN_MOUNT_SIDE,	//GUN MOUNT SIDE RED
	LAMP_INTERNAL_MARQUEE,	//INTERNAL MARQUEE BACKLIGHT
	LAMP_P1GUN_MOUNT,		//P1 GUN RED GUN MOUNT LEDS
	LAMP_P2GUN_MOUNT,		//P2 GUN BLUE GUN MOUNT LEDS
	LAMP_SEAT_BASE,			//SEAT BASE LED
	LAMP_ESTOP,				//E-STOP LAMP
	LAMP_COMPRESSOR,		//COMPRESSOR SERVICE LAMP
						
	LAMP_NUM_LIGHTS		
						
} LAMP_TYPE;			
						
						
						
						
						










void Lamps_Init();

void Lamps_Enable(int enable);
int Lamps_AreEnabled();

void Lamp_Set(int lamp, float val);
void Lamp_SetAll(float val);
float Lamp_Get(int lamp);
int Lamp_IsOn(int lamp);

void Lamp_Update();


typedef enum LAMP_FX_STATE
{
	LAMP_FX_STATE_NONE,
	LAMP_FX_STATE_DIAG,
	LAMP_FX_STATE_ATTRACT,
	LAMP_FX_STATE_LEVEL_SELECT,
	LAMP_FX_STATE_LEVEL_SELECTED,
	LAMP_FX_STATE_LOADING,
	LAMP_FX_STATE_GAME,
	LAMP_FX_STATE_SLOWMO,
	LAMP_FX_STATE_TOOK_DMG,
	LAMP_FX_STATE_WINNER_P1,
	LAMP_FX_STATE_WINNER_P2,
	LAMP_FX_STATE_ENTER_NAME,
	LAMP_FX_STATE_HST,

	NUM_LAMP_FX_STATES

} LAMP_FX_STATE;

void LampFX_SetState(LAMP_FX_STATE state);


typedef enum LAMP_GUN_STATE
{
	LAMP_GUN_STATE_NONE,
	LAMP_GUN_STATE_DIAG,
	LAMP_GUN_STATE_ATTRACT,
	LAMP_GUN_STATE_ACTIVE,
	LAMP_GUN_STATE_MINIGUN,
	LAMP_GUN_STATE_FREEZE,
	LAMP_GUN_STATE_ELECTRO,
	LAMP_GUN_STATE_SHOTGUN,

	NUM_LAMP_GUN_STATES

} LAMP_GUN_STATE;

void LampGun_SetStateAll(LAMP_GUN_STATE state);
void LampGun_SetState(int player, LAMP_GUN_STATE state);
void LampGun_SetFiring(int player, int firing);
void LampGun_Update();



#endif	// BLOWER_H
