
#ifndef LEVEL_SELECT_H
#define LEVEL_SELECT_H

enum LevelSelectMachineStates
{
	SM_LEVEL_SELECT_RUN = SM_ENEMYSTATES_MAX,
	SM_LEVEL_SELECT_BNT_FLASH,
	SM_LEVEL_SELECT_MAX,
	NUM_SM_LEVEL_SELECT_STATES = (SM_LEVEL_SELECT_MAX - SM_ENEMYSTATES_MAX + NUM_SM_ENEMYSTATES),
};

extern PSM_State gLevelSelectStateMachineStates[NUM_SM_LEVEL_SELECT_STATES];
extern PSM_StateMachine gLevelSelectStateMachine;

int LevelSelect_GetSelectedLevel();
char* LevelSelect_GetSelectedLevelTrigger();
void LevelSelect_MakeDino( char* dino, Res* tmpl_res );
void LevelSelect_PickLevel(SM_LevelSelectRun_Params* params, int level, int act);

int SM_LevelSelect_Run( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time );
int SM_LevelSelect_BntFlash( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time );







//////////////////////////////////////////////////////////////////////////
// flicker animation
//////////////////////////////////////////////////////////////////////////

typedef struct FlickerState
{
	float	glow_power;
	float	alpha;
	float	fade_time;
	float	hold_time;
} FlickerState;

typedef struct FlickerObj
{
	int state;
	float tick;
	FlickerState prevFS;
	FlickerState curFS;
	FlickerState destFS;
	ObjDispRes* odr;
	List flicker_list;
	float default_glow_power;
	float default_alpha;
} FlickerObj;

typedef struct MakeFlickerParam
{
	float min_frame;
	float max_frame;
	float time_scale;
	float max_gpwr;
	float min_variation;
	float max_variation;
	int sample_cnt;
	float final_gpwr;
	float final_alpha;
	float final_time;
}MakeFlickerParam;

extern List gFlickerObjs;
extern int gFlickerObjListCreated;

FlickerObj* Flicker_AddObj( ObjDispRes* odr, float default_gpwr, float default_alpha );
void Flicker_SetState( FlickerState* fs, float gpwr, float alpha, float fade_t, float hold_t );
void Flicker_ApplyState( ObjDispRes* odr, FlickerState* fs );
void Flicker_AppendState( FlickerObj* fo, FlickerState* new_fs );
int Flicker_SetNextState( FlickerObj* fo, List* fs_list );
void Flicker_MakeFlicker( FlickerObj* fo, MakeFlickerParam* params );
void Flicker_ResetList( FlickerObj* fo );
int Flicker_GetTotalQueuedCnt();
void Flicker_MakeRandFlick();
void Flicker_MakeTerrainRandFlick( int * hover_panels );




#endif


