
#ifndef OBS_SHOOT_GENERAL_H
#define OBS_SHOOT_GENERAL_H

enum
{
	TYPE_UNDEFINED=0,
	TYPE_FROM_ACTOR,
	TYPE_FROM_DESTRUCT_PROG
};


// obs shoot global variables in convenient struct form
typedef struct ObsShootGlobal
{
	// slow motion until objects are dead
	uns32 gSlowMoObjs[MAX_SLOWMO_OBJS];
	uns32 gSlowMoNumObjs;
	uns32 gSlowMoNoHitFlyers;
	uns32 gSlowMoCircGroupOID;
	uns32 gSlowMoObjDmgCnt;
	uns32 gSlowMoObjDmgSplat;
	int gCirclesFailed;
	uns32 gCirclesDmgTime;
} ObsShootGlobal;


// helpers
ObjExeContext* ObsShoot_FindDestructProg( Obj* prime );
SM_DestructSM_Params* ObsShoot_GetDestructParams( Obj* prime );

ObjExeContext* ObsShoot_FindObsShootProg( Obj* prime );
SM_Enemy_Params* ObsShoot_FindEnemyParams( Obj* prime );

void ObsShoot_PlayerHitFlyerOverride( ObjDispRes* odr, ObjGroup* flyers_group, SM_DestructSM_Params* dparams );

#endif


