
#ifndef OBS_SHOOT_STATEMACHINE_H
#define OBS_SHOOT_STATEMACHINE_H

#define MAX_SLOWMO_OBJS		32

enum ObjShootMachineStates
{
	SM_OBS_SHOOT_CREATE_DESTRUCT = SM_ENEMYSTATES_MAX,
	SM_OBS_SHOOT_WAITTRIGGER,
	SM_OBS_SHOOT_OVERRIDESHOT,
	SM_OBS_SHOOT_ADD_CIRCLE,
	SM_OBS_SHOOT_GOTSHOT,
	SM_OBS_SHOOT_DAMAGE_PLAYER_CIRCLES,
	SM_OBS_SHOOT_DAMAGE_PLAYER_CIRCLES_END,
	SM_OBS_SHOOT_WAITCIRCLES,
	SM_OBS_SHOOT_CIRCLE_KILLED,
	SM_OBS_SHOOT_DESTROY,
	SM_OBS_SHOOT_NO_HIT_FLYERS,
	SM_OBS_SHOOT_CHECK_PLAYER_HIT,
	SM_OBS_SHOOT_REGISTER_SLOWMO_OBJ,
	SM_OBS_SHOOT_REGISTER_SLOWMO_CIRC_OBJ,
	SM_OBS_SHOOT_ENABLE_DESTRUCT,
	SM_OBS_SHOOT_DISABLE_DESTRUCT,
	SM_OBS_SHOOT_BUG_EXP_SPLAT,
	SM_OBS_SHOOT_POO_SPLAT,

	SM_OBS_SHOOT_MAX,
	NUM_SM_OBS_SHOOT_STATES = (SM_OBS_SHOOT_MAX - SM_ENEMYSTATES_MAX + NUM_SM_ENEMYSTATES),
};

extern PSM_State gObsShootStateMachineStates[NUM_SM_OBS_SHOOT_STATES];
extern PSM_StateMachine gObsShootStateMachine;

int SM_ObsShoot_Create_Destruct( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time );
int SM_ObsShoot_WaitTrigger( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time );
int SM_ObsShoot_OverrideShot( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time );
int SM_ObsShoot_AddCircle( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time );
int SM_ObsShoot_GotShot( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time );
int SM_ObsShoot_DamagePlayerCircles( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time );
int SM_ObsShoot_DamagePlayerCirclesEnd( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time );
int SM_ObsShoot_WaitCircles( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time );
int SM_ObsShoot_CircleKilled( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time );
int SM_ObsShoot_Destroy( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time );
int SM_ObsShoot_NoHitFlyers( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time );
int SM_ObsShoot_Check_Player_Hit( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time );
int SM_ObsShoot_RegisterSlowMoObj( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time );
int SM_ObsShoot_RegisterSlowMoCircleObj( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time );
int SM_ObsShoot_EnableDestruct( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time );
int SM_ObsShoot_DisableDestruct( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time );
int SM_ObsShoot_BugExpSplat( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time );
int SM_ObsShoot_PooSplat( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time );

void ObjShoot_Reset();

#endif


