// game_hud.h
// Play Mechanix - Video Game System
// Copyright (c) 2010 Play Mechanix Inc. All Rights Reserved
//

#ifndef SCREEN_FX_H
#define SCREEN_FX_H

#include "game.h"

// types of hit effects
enum
{
	SCREEN_HIT_GENERIC,
	SCREEN_HIT_RAPTOR_SWIPE,
	SCREEN_HIT_RAPTOR_DOUBLE_SWIPE,
	SCREEN_HIT_RAPTOR_GRAB_V1,
	SCREEN_HIT_RAPTOR_GRAB_V2,
	SCREEN_HIT_RAPTOR_GRAB_V3,
	SCREEN_HIT_RAPTOR_GRAB_V4,
	SCREEN_HIT_RAPTOR_SIDE_LEFT,
	SCREEN_HIT_RAPTOR_DOWN_LEFT,
	SCREEN_HIT_RAPTOR_SIDE_RIGHT,
	SCREEN_HIT_RAPTOR_DOWN_RIGHT,
	SCREEN_HIT_MRAPTOR,
	SCREEN_HIT_PTRDON_BITE,
	SCREEN_HIT_PTRDON_CLAW,
	SCREEN_HIT_PTRDON_SWIPE_LEFT,
	SCREEN_HIT_PTRDON_SWIPE_RIGHT,
	SCREEN_HIT_WASP,
	SCREEN_HIT_COMPY,
	SCREEN_HIT_OBSTACLE,
	SCREEN_HIT_CIRCLE_DMG,
	SCREEN_HIT_FRIENDLY,
	SCREEN_HIT_DROOL,
	SCREEN_HIT_POO,
	SCREEN_HIT_DILO_SPIT,
	SCREEN_HIT_BUG_SPLAT,
	SCREEN_HIT_BUG_EXP_SPLAT,
	SCREEN_HIT_WATER_DROPS,
	SCREEN_HIT_WATER_DROPS_ROAR,
	SCREEN_HIT_WATER_DROPS_RAIN,
	SCREEN_HIT_MUD_SPLAT,
	SCREEN_HIT_RND_HIT,
	SCREEN_HIT_SPINO_SLASH,
	SCREEN_HIT_SPINO_BITE,
	SCREEN_HIT_TREX_BITE,
	SCREEN_HIT_TREX_BITE1,
	SCREEN_HIT_TREX_BITE2,
	SCREEN_HIT_TREX_BITE3,
	SCREEN_HIT_PTRDON_BOSS_CLAW,
	SCREEN_HIT_BRAC_TAIL_WACK,
	SCREEN_HIT_BRAC_HEAD_WACK,
	SCREEN_HIT_BRAC_FOOT_STOMP,
	SCREEN_HIT_FLYING_JEEP,
};


// external interactions functions
void ScreenFX_Reset();
void ScreenHitFX( int player, int player_hit_num, int type, void* data );
void ScreenFX_AddMRaptorAttPt( crd* att_pt );
void ScreenFX_KillAllEffects();

#endif // SCREEN_FX_H

