#ifndef AUD_H
#define AUD_H

// aud.h
// Copyright (c) 2010 Play Mechanix Inc. All Rights Reserved
//

#define AUD_CASHBOX		"cashbox"
#define AUD_SYSTEM		"system"
#define AUD_GAMEPLAY	"gameplay"
#define AUD_HIGHSCORES	"highscores"

// AudDef, and AudGroupDef struct defined in core_rtdt_datatypes

enum {
	AUD_ERR_NONE = 0,
	AUD_ERR_BAD_PARAMS    = -1,
	AUD_ERR_NOT_FOUND     = -2,
	AUD_ERR_GRP_NOT_FOUND = -3,
	AUD_ERR_HASH_ERR      = -5,
	AUD_ERR_FILE_ERR      = -6,
	AUD_ERR_MALLOC        = -7,
	AUD_ERR_PARSE_ERR     = -8,

};

#define AUD_SAVE_COPIES 3


int Aud_Init();
int Aud_Final();

int   Aud_AddDefs( AudDef *def, int count);
int   Aud_LoadDefs();

AudDef *Aud_GetDef( char *name );
void *Aud_Get( char *name );
int   Aud_Save( char *name );
int   Aud_Load( char *name );
int   Aud_LoadDefault( char *name );
int   Aud_Reset( char *name );
int   Aud_LoadAll( void );
int   Aud_SaveAll( void );
int   Aud_ResetAll( void );
int Aud_ExportAll();



int Aud_SetMigrateFunc( char *name, void (*MigrateFunc)(char *name, AudDef *def, int file_vers, wchar_t *file_text, void *data ) );


#endif	// AUD_H
