#ifndef DIAG_H
#define DIAG_H

// diag.h
// Play Mechanix - Video Game System
// Copyright  2011 Play Mechanix Inc. All Rights Reserved
//
// JAL 13-Jun-2011:  Cleaned up remnants of old diag. Diag now relies fully on the new menu system.

// --------------------------------------------------------------------------
// Often-used defines
// --------------------------------------------------------------------------

// diag proc name for proc system
#define DIAG_PROC					"DiagProc"

// --------------------------------------------------------------------------
// diag types
// --------------------------------------------------------------------------

// Startup and exit function callback types
typedef void (*diag_startup_function_cb)(void);
typedef void (*diag_exit_function_cb)(int enterGunCal);

// --------------------------------------------------------------------------
// external function declarations
// --------------------------------------------------------------------------

EXTERN_C int DiagIsActive(void);

EXTERN_C int DiagAddStartupFunctionCB(diag_startup_function_cb DiagStartCB);
EXTERN_C int DiagAddExitFunctionCB(diag_exit_function_cb DiagExitCB);

EXTERN_C void DiagRequestScreenOnExit(int diagExitScreen);

EXTERN_C void DiagSetup(void);
EXTERN_C int DiagInit(void);
EXTERN_C int DiagStart(char *menu);
EXTERN_C void DiagRecreateMenus(char* newStartingMenu);

EXTERN_C void DiagFinal(void);

#define DIAG_MENU_INSTALL_TYPE(menuType)	\
	ec = MenuInstallMenuType(menuType);	\
	if( ec < 0 )	\
	{\
		ASSERT(0, "failed to install menu type");\
		return ec;\
	}\
		
#define DIAG_MENU_INSTALL(menu, parent)	\
	ec = MenuInstallMenu(menu, parent);	\
	if( ec < 0 )	\
	{\
		ASSERT(0, "failed to install menu");\
		return ec;\
	}\
		
#define DIAG_MENU_INSTALL_ADJ(group, name, parent)	\
	ec = AdjMenuInstallAdjustment(group, name, parent);	\
	if( ec < 0 )	\
	{\
		ASSERT(0, "failed to install menu %s", name);\
		return ec;\
	}\

typedef int (*DiagMenuInstallCB)();
EXTERN_C void DiagSetMenuInstallCB(DiagMenuInstallCB cb);

EXTERN_C int DiagMenuInstall();

EXTERN_C menu_t DiagMenuMain;
EXTERN_C menu_t DiagMenuDiagnostics;
EXTERN_C menu_t DiagMenuPricing;
EXTERN_C menu_t DiagMenuGameAdjustments;
EXTERN_C menu_t DiagMenuSysAdjustments;
EXTERN_C menu_t DiagMenuAudits;
EXTERN_C menu_t DiagMenuUtilities;
EXTERN_C menu_t DiagMenuCalibrate;

#endif	// DIAG_H

