#ifndef FS_H
#define FS_H
// fs.h
// Copyright 1998-2004 Play Mechanix Inc. All Rights Reserved
//
// JFL 26 Aug 04

#include "g5.h"

/*
///////////////////////////////////////////////////////////////////////////////
// SYSTEM DEPENDENT

//-----------------------------------------------------------------------------
// SYS_PC SYS_BB
#if SYS_PC|SYS_BB

typedef struct {
	uns x[16]; // private structe
} FsH;

typedef struct {
	uns x[8]; // private structe
} FfH;

#define FS_DIR_SLASH '/'



#endif // SYS_PC|SYS_BB
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------


///////////////////////////////////////////////////////////////////////////////
// SYSTEM INDEPENDENT

#define FSDIR_FIRST 0x01
#define FSDIR_NEXT	0x02
#define FSDIR_SAME	0x04

#define M_FSOPEN_CREATEIFNOTFOUND 0x01
#define M_FSOPEN_DELETEDATA 0x02
#define M_FSOPEN_WRITABLE 0x04
#define M_FSOPEN_APPEND 0x08
#define M_FSOPEN_ATOMIC 0x10

enum {
	FSINFO_NONE,
	FSINFO_SECTOR_SIZE,
	FSINFO_CLUSTER_SIZE,
};

typedef struct {
    
    // this must fit into FsH declared in fs.h
    uns16	flags;
    FILE	*fh;
} FileRec;

#define M_FF_VALID 0x01
typedef struct {
    
    // this must fit into FfH declared in fs.h
    uns8	flags;
    FILE	*fh;
} FastFile;

extern int FsInit(void);
extern void FsFinal(void);
extern int FsReset(uns reset);

extern int FsOpen(FsH *fh,char *path,uns flags);
extern int FsFindOpen(FsH *fh,char *pathlist,char *name,uns flags,
					  char *foundpath,int foundpathsize);
extern int FsDelete(char *path);
extern int FsRename(char *oldpath,char *newpath);
extern int FsClose(FsH *fh);
extern int FsFlush(FsH *fh);
extern int FsSync(FsH *fh);
extern int FsRead(FsH *fh,void *buf,uns32 size);
extern int FsWrite(FsH *fh,void *buf,uns32 size);
extern int FsDefrag(FsH *fh,int set);
extern int FsSeek(FsH *fh,uns32 off);
extern uns FsSize(FsH *fh);
extern int FsDiskSize(FsH *fh,int set,uns *sizep);
extern int FsDir(FsH *fh,uns n,char *buf,uns bufsize);
extern int FsCurDir(int num,int set,char *buf,uns bufsize);
extern sto FsInfo(int info);
extern int FsDirCheck(char* dirName);



#define M_FF_ALIGN (3)

extern int FfPrep(FfH *ff,FsH *fh);
extern int FfRead(FfH *ff,void *buf,uns32 size);
extern int FfWrite(FfH *ff,void *abuf,uns32 size);
extern int FfSeek(FfH *ff,uns32 off);

enum {
	FSOPTYPE_NONE,
	FSOPTYPE_ADJ,
	FSOPTYPE_AUD,
	FSOPTYPE_CF,
	FSOPTYPE_TRNY,
	FSOPTYPE_PLAYER,
	FSOPTYPE_LBOARD,
};
enum {
	FSOP_NONE,
	FSOP_OPEN,
	FSOP_CREATE,
	FSOP_CLOSE,
	FSOP_OPENREADCLOSE,
	FSOP_CREATEWRITECLOSE,
};
#define M_FSOP        0xff
#define M_FSOP_ATOMIC 0x0100

extern int FsOp(FsH *fh,char *name,uns type,uns op,void *buf,uns bufSize);
*/

#endif // ndef FS_H
