#ifndef GCON_H
#define GCON_H
// gcon.h
// Copyright 1998-2004 Play Mechanix Inc. All Rights Reserved
//
// JFL 08 Dec 04

extern void GConOutputLine(char *fmt,...);
extern void GConOutputReprintLine(char *fmt,...);
extern int GConInit(void);
extern void GConFinal(void);
extern int GConStart(void);
extern int GConLoop(void);

extern int GConActive(void);

#if !PRODUCTION
	#define M_GCON_ON       0x00000001
	#define M_GCON_OPEN     0x00000004
	#define M_GCON_SKIP     0x00000008
	#define M_GCON_PAGE     0x00000010
	#define M_GCON_UP       0x00000020
	#define M_GCON_DOWN     0x00000040
	#define M_GCON_ADR      0x00000080
	#define M_GCON_LEVEL    0x00000200
	#define M_GCON_FLAGS    0x00000400
	#define M_GCON_MOUSECAM 0x00000800
	#define M_GCON_TIMING   0x00001000
	#define M_GCON_DETAIL1  0x00002000
	#define M_GCON_DEL      0x00004000

	typedef struct {
		uns flags;
		uns8 list;
		int rlayer; // current render layer
		int rlist; // current render list
		ObjText *text1;
		ObjText *text2;
		ObjBuf *buf1;
		Res *resParse;
		int objtop;
		int objn;
		int coltop;
		int coln;
		int restop;
		int resn;
		int proctop;
		int procn;
		int trigtop;
		int trign;
		int eventtop;
		int eventn;
		int physxtop;
		int helptop;

		int rlisttop[NUM_RENDERLAYERS][NUM_RENDERLAYER_RENDERLISTS];

		float camm[3];
		float camv[3];

		int lampdbg;

	} GConRec;

	extern GConRec gconG;

#endif // !PRODUCTION

#endif // ndef GCON_H
