#ifndef MEM_H
#define MEM_H
// mem.h
// Copyright 1998-2004 Play Mechanix Inc. All Rights Reserved
//
// GNP 05 May 00
// JFL 26 Aug 04

///////////////////////////////////////////////////////////////////////////////
// SYSTEM DEPENDENT



///////////////////////////////////////////////////////////////////////////////
// SYSTEM INDEPENDENT


#define USE_MEM_TRACKER 0

#define MEM_TRACK_PRINT_BEFORE_WIPEOUT 0

#define MEM_TRACK_EACH_RES 0


#define VERBOSE_MEM_LOG 0
#define VERBOSE_MEM_LOG_DETAILS 0
#define VERBOSE_MEM_LOG_FREQ 1000

// memory sizes in bytes (1MB=0x100000)
#define KBYTES 1024
#define MBYTES 1024*1024

#define MemAlloc(size, descr)	(_MemAlloc(size, descr, __FILE__, __LINE__))
EXTERN_C void *_MemAlloc( size_t size, char *descr, char* file, int line);
void *MemRealloc( void *old, size_t size );
void *MemAlloz( size_t size, char *descr );
EXTERN_C void MemFree( void *addr );

// MemAlloc wrappers for various subsystems
// these are setup so they can be used in place of malloc
void *MemAllocCoreConfig( size_t size );
void *MemAllocCoreRTDT( size_t size );

void *MemAllocPMRT_Messages( size_t size );
void *MemAllocPSM_Engine( size_t size );
void *MemAllocTool2( size_t size );
void *MemAllocTool2Scene( size_t size );
void *MemAllocTool2SceneScratch( size_t size );
void *MemAllocPostFX( size_t size );

/*
void *MemAllocTool2SceneXML( size_t size );
void *MemAllocTool2SceneLoad( size_t size );
void *MemAllocTool2SceneList( size_t size );
void *MemAllocTool2SceneObj( size_t size );
*/

void *MemAllocSceneXML( size_t size );
void *MemAllocSceneLoad( size_t size );
void *MemAllocSceneList( size_t size );
void *MemAllocSceneObj( size_t size );

// Sound
void *MemAllocSound( size_t size );			// Memory allocation for sound


void *MemAllocObjQ( size_t size );
void *MemAllocFXPlane( size_t size );
void *MemAllocParticles( size_t size );
void *MemAllocRes( size_t size );
void *MemAllocResAttrs( size_t size );
void *MemAllocObj( size_t size );
void *MemAllocObjGndCol( size_t size );
void *MemAllocTriggers( size_t size );
void *MemAllocSnd( size_t size );
void *MemAllocAniConf( size_t size );
void *MemAllocAniAction( size_t size );
void *MemAllocJamma( size_t size );
void *MemAllocGameCard( size_t size );
void *MemAllocDongle( size_t size );
void *MemAllocTheora( size_t size );
void *MemAllocTMAP( size_t size );
void *MemAllocDiag( size_t size );
void *MemAllocFileCrypto( size_t size );
void *MemAllocGLTrack( size_t size );
void *MemAllocCabLights( size_t size );
void *MemAllocJoystick( size_t size );
void *MemAllocGLGZ( size_t size );
void *MemAllocFont( size_t size );
void *MemAllocGndCol( size_t size );

void *MemAllocWind( size_t size );
void *MemAllocFlyer( size_t size );
void *MemAllocParticlesLoadXML( size_t size );

EXTERN_C void *MemAllocCollision( size_t size );
EXTERN_C void *MemAllocPhysX( size_t size );

// game related mallocs
void *MemAllocGameConfig( size_t size );
// use these two for lists that are created and destroyed quickly w/in the same funciton
void *MemAllocCoreScratch( size_t size );
void *MemAllocGameScratch( size_t size );

EXTERN_C void *MemAllocRTColl( size_t size );


extern int MemInit(void);
extern void MemFinal(void);
extern int MemInfo(char *buf,int bufSize);

char* MemUsageStr();

#define MemCopy(dst, src, size) memcpy(dst, src, size)
#define MemZero(mem, size) memset(mem, 0, size)

#define MemCpy MemCopy
#define MEMZ(_mem_) MemZero(&(_mem_),sizeof(_mem_))



extern unsigned char gNoisePool4[1024]; // used by dongle noise function




#endif // ndef MEM_H
