// resets_diag.h
// Copyright (c) 2011 Play Mechanix Inc. All Rights Reserved
//
// JAL 29-Mar-2011: Adjustments-related diag functionality

#ifndef RESETS_DIAG_H
#define RESETS_DIAG_H

// Resets menu priorities
#define DIAG_PRI_RESETS  5	// Where the main resets menu sits in the main diag menu

typedef enum DiagMenuResetPriority
{
	DIAG_PRI_RESET_ALL_AUDITS = 1,
	DIAG_PRI_RESET_COIN_AUDITS,
	DIAG_PRI_RESET_CREDITS,
	DIAG_PRI_RESET_ALL_ADJ,
	DIAG_PRI_RESET_FACTORY_DEFAULT,
	DIAG_MENU_CORE_RESET_PRIORITY_END,
} DiagMenuResetPriority;

EXTERN_C int ResetsDiagInit(void);

EXTERN_C int MenuCreateResetMenu(menu_t *menu, menu_instance_t *inst, menu_details_t menuDetails);

EXTERN_C menu_type_t MenuType_DiagResetAllAudits;
EXTERN_C menu_type_t MenuType_DiagResetCoinAudits;
EXTERN_C menu_type_t MenuType_DiagResetCredits;
EXTERN_C menu_type_t MenuType_DiagResetHST;
EXTERN_C menu_type_t MenuType_DiagResetAllAdj;
EXTERN_C menu_type_t MenuType_DiagFactoryReset;
EXTERN_C menu_t DiagMenuResets;
EXTERN_C menu_t DiagMenuResetsResetAllAudits;
EXTERN_C menu_t DiagMenuResetsResetCoinAudits;
EXTERN_C menu_t DiagMenuResetsResetCredits;
EXTERN_C menu_t DiagMenuResetsResetHST;
EXTERN_C menu_t DiagMenuResetsResetAllAdj;
EXTERN_C menu_t DiagMenuResetsFactoryReset;

#endif // ndef RESETS_DIAG_H

// EOF

