#ifndef SCENE_MNGR_H
#define SCENE_MNGR_H
//scene_manager.h
// Copyright 1998-2004 Play Mechanix Inc. All Rights Reserved
//

#ifdef __cplusplus
#define EXTERN_C	extern "C"
#else
#define EXTERN_C	extern
#endif

#include "g5.h"


void *MemAllocSceneManager( size_t size );

int SceneManagerInit(void);
int SceneManagerReset(void);
int SceneManagerFinal(void);

void SceneManagerLoop(uns64 max_time, int max_interations);


int SceneManagerLoad(char *name);
int SceneManagerLoadRes(char *name);
int SceneManagerPlay(char *name, int do_scene_start_trigger, char* custom_trigger);
void SceneManagerEnd( char *name, int do_scene_end_trigger );
int SceneManagerUnload(char *name);

int SceneManagerGetState(char *name);
int SceneManagerIsPlaying(char *name);
int SceneManagerIsLoading(char *name);

SceneType *SceneManagerGetScene(char *name);

// this is a blocking scene load command
// first it will end/wipeout any existing scene
// next, it will block until the scene and all of it's resources and programs are loaded
// finally, it will then start the scene
int SceneManagerPlayNow(char *name, char* custom_trigger);

// same as above, but will proc sleep while scene loads
int SceneManagerPlayNowProc(char *name);

// same as above, but does not start the scene
int SceneManagerLoadNow(char *name);
int SceneManagerLoadNowProc(char *name);


int SceneManagerGcon(char *buf);


int SceneManagerCreateActor( char *scene, char *actor, Obj **o, Obj* overrideObj);
int SceneManagerFindActorByName( char *scene, char *actor, uns32 *oid );
int SceneManagerKillActor( char *scene, char *actor );
int SceneManagerKillActorsByRes( char *scene, char *resname );

#endif // ndef SCENE_MNGR_H
