#ifndef SYSTEM_TESTS_DIAG_H
#define SYSTEM_TESTS_DIAG_H

// system_tests_diag.h
// Copyright (c) 2011 Play Mechanix Inc. All Rights Reserved
//
// JAL 14-Mar-2011: System Tests-related diag functionality

// System Tests menu priorities
#define DIAG_PRI_TESTS				5
#define DIAG_PRI_TESTS_INPUT		1
#define DIAG_PRI_TESTS_IN_SWITCH	2

#define DIAG_PRI_TESTS_OUTPUT		1
#define DIAG_PRI_TESTS_OUT_LAMP		2
#define DIAG_PRI_TESTS_OUT_SOUND	3

#define DIAG_PRI_TESTS_OUT_SOUND_SUB1	1
#define DIAG_PRI_TESTS_OUT_SOUND_SUB2	2
#define DIAG_PRI_TESTS_OUT_SOUND_SUB3	3
#define DIAG_PRI_TESTS_OUT_SOUND_SUB4	4
#define DIAG_PRI_TESTS_OUT_SOUND_SUB5	5
#define DIAG_PRI_TESTS_OUT_SOUND_SUB6	6


// --------------------------------------------------------------------------
EXTERN_C int SystemTestsDiagInit(void);


EXTERN_C menu_type_t MenuType_DiagSwitchTests;
EXTERN_C menu_type_t MenuType_ScrollingSoundTest;
EXTERN_C menu_type_t MenuType_ScrollingLightMDXTest;
EXTERN_C menu_type_t MenuType_ScrollingLightMBNTest;
EXTERN_C menu_type_t MenuType_ScrollingLightENVTest;
EXTERN_C menu_type_t MenuType_MonitorTest;
EXTERN_C menu_type_t MenuType_CoinMeterTest;
EXTERN_C menu_t DiagMenuTests;
EXTERN_C menu_t DiagMenuSwitchTests;
EXTERN_C menu_t DiagMenuSoundTests;
EXTERN_C menu_t DiagMenuLightTests;
EXTERN_C menu_t DiagMenuMonitorTest;
EXTERN_C menu_t DiagMenuCoinMeterTest;


#define DIAGTEST_ITEM(var, order)	\
	menu_t var =					\
{									\
#var,								\
	"MenuType_ScrollingList",		\
	"Diag",							\
	"DiagIconTest",					\
	"",								\
	order,							\
	"DiagIconNULL",					\
	"DiagMenuBttnLblScrollUp",		\
	"DiagIconNULL",					\
	"DiagMenuBttnLblScrollDown",	\
	"DiagIconNULL",					\
	"DiagMenuBttnLblSelect",		\
	"DiagIconNULL",					\
	"DiagMenuBttnLblBack",			\
};
#define DIAGTEST_ITEM_VALUE(var, order)	\
	menu_t var =					\
{									\
#var,								\
	"MenuType_ScrollingList",		\
	"Diag",							\
	"DiagIconTest",					\
#var "_VALUE",								\
	order,							\
	"DiagIconNULL",					\
	"DiagMenuBttnLblScrollUp",		\
	"DiagIconNULL",					\
	"DiagMenuBttnLblScrollDown",	\
	"DiagIconNULL",					\
	"DiagMenuBttnLblSelect",		\
	"DiagIconNULL",					\
	"DiagMenuBttnLblBack",			\
};

#define DIAGTEST_DECL(var) menu_t var


EXTERN_C DIAGTEST_DECL(DiagMenuSoundTest1000HzStereo		);
EXTERN_C DIAGTEST_DECL(DiagMenuSoundTest1000HzLeftOnly	);
EXTERN_C DIAGTEST_DECL(DiagMenuSoundTest1000HzRightOnly	);
EXTERN_C DIAGTEST_DECL(DiagMenuSoundTest100HzStereo		);
EXTERN_C DIAGTEST_DECL(DiagMenuSoundTest100HzLeftOnly	);
EXTERN_C DIAGTEST_DECL(DiagMenuSoundTest100HzRightOnly	);
EXTERN_C DIAGTEST_DECL(DiagMenuSoundTestRumble1			);
EXTERN_C DIAGTEST_DECL(DiagMenuSoundTestRumble2			);
EXTERN_C DIAGTEST_DECL(DiagMenuSoundTestRumble3			);
EXTERN_C DIAGTEST_DECL(DiagMenuSoundTestRumble4			);
EXTERN_C DIAGTEST_DECL(DiagMenuSoundTestRumble5			);
EXTERN_C DIAGTEST_DECL(DiagMenuSoundTestRumble6			);
EXTERN_C DIAGTEST_DECL(DiagMenuSoundTestRumble7			);
EXTERN_C DIAGTEST_DECL(DiagMenuSoundTestRumble8			);
EXTERN_C DIAGTEST_DECL(DiagMenuSoundTestRumble9			);


int DiagMenuLightMDXInstall();
int DiagMenuLightMBNInstall();
int DiagMenuLightENVInstall();
int DiagMenuLightMT1Install();
int DiagMenuLightAllInstall();


#endif // ndef SYSTEM_TESTS_DIAG_H

